/*
 * Copyright (c) 2012, Brandon Falk <bfalk@brandonfa.lk>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 	1. Redistributions of source code must retain the above copyright notice,
 * 	this list of conditions and the following disclaimer.
 *
 * 	2. Redistributions in binary form must reproduce the above copyright
 * 	notice, this list of conditions and the following disclaimer in the
 * 	documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _API_H_
#define _API_H_

#define IOCTL_REQ_MEM \
	CTL_CODE(FILE_DEVICE_DATALINK, 0x1337, METHOD_BUFFERED, FILE_ANY_ACCESS)

/* Error with the input to the driver */
#define PMERR_INPUT    1
/* Error with the output pointed given to the driver */
#define PMERR_OUTPUT   2
/* Internal error, when the driver can not get the physical memory */
#define PMERR_INTERNAL 3
/* Bounds error */
#define PMERR_BOUNDS   4

#define PM_READ  0
#define PM_WRITE 1

#pragma pack(push, 1)
struct _reqmem {
	uint64_t loc;
	uint32_t size;
	uint32_t write;
};
#pragma pack(pop)

HANDLE
getdh(void);

int
iomem(HANDLE dh, unsigned char *ptr, uint64_t loc, uint32_t size,
		uint32_t write);

#endif

